%% Filtrovani v prostorove domene
%% Korelace

f = [0 0 0 1 0 0 0];
w = [1 2 3 2 8];

g = imfilter(f,w,'corr','same')
%% Konvoluce

f = [0 0 0 1 0 0 0];
w = [1 2 3 2 8];
g = imfilter(f,w,'conv','same')
%% Korelace ve 2D

f = [ 0 0 0 0 0; 
      0 0 0 0 0; 
      0 0 1 0 0; 
      0 0 0 0 0; 
      0 0 0 0 0];

w = [ 1 2 3; 
      4 5 6; 
      7 8 9];
g = imfilter(f,w,'corr','same')
%% Konvoluce ve 2D

g = imfilter(f,w,'conv','same')
%% Vyhlazovaci filtry
% Filtarce prumerovanim

B = imread('lenagraysum.bmp');
w = 1/9 * [1 1 1; 
           1 1 1; 
           1 1 1];

C = imfilter(B,w,'corr','same');
figure, imshow(C);
figure, imshow(B);
%% Vazene prumerovani

B = imread('lenagraysum.bmp');
w = 1/16 * [1 2 1; 
            2 4 2; 
            1 2 1];

C = imfilter(B,w,'corr','same');
figure, imshow(C);
%% Medianová filtrace

B = imread('lenagraysum2.bmp');
w = 1/9 * [1 1 1; 
           1 1 1; 
           1 1 1];

C = imfilter(B,w,'corr','same');

C2 = medfilt2( B,[3 3] );

figure
subplot(1,2,1)
imshow(C,[])
title('prumer')
subplot(1,2,2)
imshow(C2,[])
title('median')
%% Ostrici filtry
% Laplaceuv operator

I = imread('pastelkygrayblurred.png');
w = -[-1 -1 -1; 
      -1 8 -1; 
      -1 -1 -1];
     
w2 = -[0 -1 0; 
      -1 4 -1; 
       0 -1 0];

C = imfilter(I,w,'corr','same');
C2 = imfilter(I,w2,'corr','same');

figure
subplot(2,3,1)
imshow(I,[])
subplot(2,3,2)
imshow(C,[])
subplot(2,3,3)
imshow(I-C,[])

subplot(2,3,4)
imshow(I,[])
subplot(2,3,5)
imshow(C2,[])
subplot(2,3,6)
imshow(I-C2,[])
%% Zvýraznění hran - ostreni

w2 = -[0 -1 0; 
      -1 3 -1; 
       0 -1 0];

C2 = imfilter(I,w2,'corr','same');
imshow(C2,[])

%% Robertsuv operator

I = imread('pastelkygray.jpg');
w = [-1 -1; 
      1 1];

I2 = imfilter(I,w,'corr','same');

figure
subplot(1,2,1)
imshow(I,[])
subplot(1,2,2)
imshow(I2,[])
%% Sobeluv operator
% vodorovne hrany

I = imread('trojuhelnik.png');
w = [-1 -2 -1; 
      0 0 0 ; 
      1 2 1];
I2 = imfilter(I,w,'corr','same');

figure
subplot(1,2,1)
imshow(I,[])
subplot(1,2,2)
imshow(I2,[])
%% svisle hrany

I = imread('trojuhelnik.png');
w = [-1 0 1; 
     -2 0 2 ; 
     -1 0 1];

I2 = imfilter(I,w,'corr','same');

figure
subplot(1,2,1)
imshow(I,[])
subplot(1,2,2)
imshow(I2,[])
%% diagonalni hrany

I = imread('pastelkygray.jpg');
w = [0 2 2;
    -2 0 2 ; 
    -2 -2 0];

I2 = imfilter(I,w,'corr','same');

figure
subplot(1,2,1)
imshow(I,[])
subplot(1,2,2)
imshow(I2,[])
%% diagonální hrany

I = imread('pastelkygray.jpg');
w = [0 1 2;
    -1 0 1; 
   -2 -1 0];

I2 = imfilter(I,w,'corr','same');

figure
subplot(1,2,1)
imshow(I,[])
subplot(1,2,2)
imshow(I2,[])
%% Filtrovani barevnych obrazku
I = imread('pastelky.png');
Ir = I(:,:,1);
Ig = I(:,:,2);
Ib = I(:,:,3);

w1 = fspecial('average',5);
Jr = imfilter(Ir,w1,'same');
Jg = imfilter(Ig,w1,'same');
Jb = imfilter(Ib,w1,'same');

J=uint8([]);

J(:,:,1) = Jr;
J(:,:,2) = Jg;
J(:,:,3) = Jb;


figure
subplot(1,2,1)
imshow(I,[])
subplot(1,2,2)
imshow(J,[])

%%
I = imread('pastelky.png');
I2 = rgb2hsv(I);
w1 = fspecial('average',5);
I2(:,:,3) = imfilter(I2(:,:,3) ,w1,'same');
J2 = im2uint8(hsv2rgb(I2));

figure
subplot(1,2,1)
imshow(I,[])
subplot(1,2,2)
imshow(J2,[])
%%
K = double(J)-double(J2);
L = K(:,:,1)/3 + K(:,:,2)/3 + K(:,:,3)/3;

figure
subplot(1,3,1)
imshow(I,[])
subplot(1,3,2)
imshow(J2,[])
subplot(1,3,3)
imshow(L,[])


%%
I = imread('pastelky.png');
Ir = I(:,:,1);
Ig = I(:,:,2);
Ib = I(:,:,3);

w1 = fspecial('laplacian');
Jr = Ir + imfilter(Ir,w1,'same');
Jg = Ig + imfilter(Ig,w1,'same');
Jb = Ib + imfilter(Ib,w1,'same');

J = uint8([]);
J(:,:,1) = Jr;
J(:,:,2) = Jg;
J(:,:,3) = Jb;


figure
subplot(1,2,1)
imshow(I,[])
subplot(1,2,2)
imshow(J,[])

%%
I = imread('pastelky.png');
I2 = rgb2hsv(I);
w1 = fspecial('laplacian');
I2(:,:,3) = I2(:,:,3) + imfilter(I2(:,:,3) ,w1,'same');
J2 = hsv2rgb(I2);

figure
subplot(1,2,1)
imshow(I,[])
subplot(1,2,2)
imshow(J2,[])

%% Ostreni - jinym zpusobem

I = imread('pastelkygray.jpg');
f = 1/36 * ones(6);
Iblur = imfilter(I,f,'corr','same');
mask = I - Iblur;
Isharp = I + 2* mask;

figure
subplot(2,2,1)
imshow(I,[])
subplot(2,2,2)
imshow(Iblur,[])
subplot(2,2,3)
imshow(mask,[])
subplot(2,2,4)
imshow(Isharp,[])